/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import { OnModuleDestroy, OnModuleInit } from '@nestjs/common';
import { PutObjectCommandOutput, S3Client } from '@aws-sdk/client-s3';
import { StorageModuleOptions } from './interfaces';
import * as fs from 'fs';
import { PassThrough } from 'stream';
interface testO {
    [key: string]: string | testO;
}
export declare class StorageService implements OnModuleInit, OnModuleDestroy {
    private options;
    private s3Client;
    private readonly useFileSystem;
    private readonly endpoint?;
    private readonly region?;
    private readonly bucket?;
    private readonly accessKeyId?;
    private readonly secretAccessKey?;
    constructor(options: StorageModuleOptions);
    get client(): S3Client | undefined;
    get useCloud(): boolean;
    createTest(test: testO, location: string): Promise<void>;
    readTest(test: testO, location: string): Promise<void>;
    deleteTest(test: testO, location: string): Promise<void>;
    onModuleInit(): Promise<void>;
    onModuleDestroy(): Promise<void | undefined>;
    private normalizeDirKey;
    private normalizeKey;
    mkdir(folderPath: string, bucket?: string): Promise<PutObjectCommandOutput | string | undefined>;
    readdir(folderPath: string, bucket?: string): Promise<string[]>;
    rmdir(folderPath: string, bucket?: string): Promise<void>;
    exists(path: string, bucket?: string): Promise<boolean>;
    readFile(filePath: string, bucket?: string): Promise<Buffer>;
    writeFile(filePath: string, data: string | Buffer, bucket?: string): Promise<void>;
    rm(filePath: string, bucket?: string): Promise<void>;
    createWriteStream(filePath: string, options?: {
        highWaterMark: number;
    }, bucket?: string): fs.WriteStream | PassThrough;
}
export {};
